"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EchartsComponent = EchartsComponent;
const echarts = __importStar(require("echarts"));
const react_1 = __importStar(require("react"));
function EchartsComponent(_a) {
    var { option, notMerge, lazyUpdate, replaceMerge, silent, transition, onInit, eventsHandler = {}, theme, opts } = _a, htmlAtt = __rest(_a, ["option", "notMerge", "lazyUpdate", "replaceMerge", "silent", "transition", "onInit", "eventsHandler", "theme", "opts"]);
    let [_, makeReady] = (0, react_1.useReducer)(() => true, false);
    (0, react_1.useEffect)(() => {
        setTimeout(() => makeReady(), 0);
    });
    const el = (0, react_1.useRef)(null);
    const currentTheme = (0, react_1.useRef)(null);
    const currentOpts = (0, react_1.useRef)(null);
    const currentEventsHandler = (0, react_1.useRef)(null);
    let instance = undefined;
    const container = el === null || el === void 0 ? void 0 : el.current;
    if (container !== null) {
        if (currentTheme.current !== theme || currentOpts.current !== opts) {
            currentTheme.current = theme;
            currentOpts.current = opts;
            echarts.dispose(container);
            const ec = echarts.init(container, theme, opts);
            if (typeof onInit === "function")
                onInit(ec);
        }
        instance = echarts.getInstanceByDom(container);
    }
    if (instance !== undefined) {
        if (option !== undefined)
            instance.setOption(option, { notMerge, lazyUpdate, replaceMerge, silent, transition });
        if (currentEventsHandler.current !== eventsHandler) {
            let events = Object.keys(currentEventsHandler);
            for (let event of events) {
                instance.off(event);
            }
        }
        for (let [event, handler] of Object.entries(eventsHandler)) {
            instance.on(event.toLowerCase(), handler);
        }
    }
    return react_1.default.createElement("div", Object.assign({ "data-testid": "EchartsComponent", ref: el }, htmlAtt));
}
//# sourceMappingURL=index.js.map